/*
 ============================================================================
 Name        : C_hello.c
 Author      : Gerd Wiegand
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CONCAT_(a,b) a##b
#define CONCAT(a,b) CONCAT_(a,b)
#define STRING_(x) #x
#define STRING(x) STRING_(x)

#define TEST(x) STRING(CONCAT(x, txt))

const char* test = TEST(hallo);

int g_var = 0;

enum
{
	ERSTER = 1,
	ZWEITER = 2
};

typedef struct
{
	int a;
	int b;
	int c;
	int d;
	int e;
	long f;
	int g;

} TMyStruct;

typedef struct
{
	int b0 : 1;
	int b1 : 1;
	int b2 : 1;
	int b3 : 1;
	int b4 : 1;
	int b5 : 1;
	int b6 : 1;
} TBitField;

typedef union
{
	TBitField bit;
	unsigned int all;
} TBitUnion;

typedef struct
{
	TBitField b1;
	TBitField b2;
	TBitField b3;
	TBitField b4;
} TConcat;

int GetVar()
{
	return g_var;
}

static inline int get_var_1() { return GetVar();} static inline int get_var_2() { return GetVar();}  static inline int get_var_3() { return GetVar();}

union MyUnion
{
	unsigned long all;
	TMyStruct elem;
};

union MyUnion s;

void *dummy;

int main(void)
{
	int a = 1;
	TBitUnion un = {0};

	puts("!!!Hello World!!!"); /* prints !!!Hello World!!! */

	un.bit.b0 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b1 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b2 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b3 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b4 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b5 = 1;
	printf("Value = %u\n", un.all);

	un.all = 0;
	un.bit.b6 = 1;
	printf("Value = %u\n", un.all);


	return EXIT_SUCCESS;
}
